# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAwsCredentialsResult',
    'AwaitableGetAwsCredentialsResult',
    'get_aws_credentials',
    'get_aws_credentials_output',
]

@pulumi.output_type
class GetAwsCredentialsResult:
    """
    A collection of values returned by getAwsCredentials.
    """
    def __init__(__self__, id=None, name=None, organization_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Id of the AWS credentials.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the aws credentials.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        Id of the organization.
        """
        return pulumi.get(self, "organization_id")


class AwaitableGetAwsCredentialsResult(GetAwsCredentialsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAwsCredentialsResult(
            id=self.id,
            name=self.name,
            organization_id=self.organization_id)


def get_aws_credentials(id: Optional[str] = None,
                        organization_id: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAwsCredentialsResult:
    """
    ## # AwsCredentials (Data Source)

    Provides a Qovery AWS credentials resource. This can be used to create and manage Qovery AWS credentials.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_qovery as qovery

    my_aws_creds = qovery.get_aws_credentials(id="<credentials_id>",
        organization_id="<organization_id>")
    ```


    :param str id: Id of the AWS credentials.
    :param str organization_id: Id of the organization.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['organizationId'] = organization_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('qovery:index/getAwsCredentials:getAwsCredentials', __args__, opts=opts, typ=GetAwsCredentialsResult).value

    return AwaitableGetAwsCredentialsResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        organization_id=pulumi.get(__ret__, 'organization_id'))


@_utilities.lift_output_func(get_aws_credentials)
def get_aws_credentials_output(id: Optional[pulumi.Input[str]] = None,
                               organization_id: Optional[pulumi.Input[str]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAwsCredentialsResult]:
    """
    ## # AwsCredentials (Data Source)

    Provides a Qovery AWS credentials resource. This can be used to create and manage Qovery AWS credentials.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_qovery as qovery

    my_aws_creds = qovery.get_aws_credentials(id="<credentials_id>",
        organization_id="<organization_id>")
    ```


    :param str id: Id of the AWS credentials.
    :param str organization_id: Id of the organization.
    """
    ...
